import { ConservativeUnary, Dependency, ImpType, Signature } from "../core/Dispatcher";

declare module "./type" {
  interface GenericReturn<Params> {
    // Jos: not sure how to define this or why it is needed
    square: Signature<Params, [T], T>
    // square: ConservativeUnary<Params, T>
    // square: Params extends [infer R]
    //   ? R extends number ? UnderlyingReal<R> : never
    //    : never
  }
}

export const square =
  <T>(dep: Dependency<'multiply', [T, T]>):
    ImpType<'square', [T]> =>
    z => dep.multiply(z, z)
